// Iterative and recursive versions of fibonacci number calculations
public class Fibonacci{
  // Recursive version
  public static int fibR(int n){
    if(n==1){
      return 1;
    }
    if(n==0){
      return 0;
    }
    else{
      return fibR(n-1) + fibR(n-2);
    }
  }
  // Iterative version, a little tricky
  public static int fibI(int n){
    int f1 = 1;
    int f2 = 0;
    int fn = 0;
    // Loop
    for(int i=0; i < n; i++){
      fn = f1 + f2;
      f1 = f2;
      f2 = fn;
    }
    return fn;
    
  }

  public static void main(String args[]){
    if(args.length < 1){
      System.out.println("usage: java Fibonacci N");
      return;
    }
    // Try timing these
    System.out.println( fibI(Integer.parseInt(args[0])) );
    // System.out.println( fibR(Integer.parseInt(args[0])) );
  }

}
